from enum import Enum, IntEnum

class Effect(IntEnum):
    none = 0,
    coding_sequence_variant = 1,
    chromosome = 2<<0,
    inframe_insertion = 2<<1,
    disruptive_inframe_insertion = 2<<2,
    inframe_deletion = 2<<3,
    disruptive_inframe_deletion = 2<<4,
    downstream_gene_variant = 2<<5,
    exon_variant = 2<<6,
    exon_loss_variant = 2<<7,
    frameshift_variant = 2<<8,
    gene_variant = 2<<9,
    intergenic_region = 2<<10,
    conserved_intergenic_variant = 2<<11,
    intragenic_variant = 2<<12,
    intron_variant = 2<<13,
    conserved_intron_variant = 2<<14,
    miRNA = 2<<15,
    missense_variant = 2<<16,
    initiator_codon_variant = 2<<17,
    non_coding_exon_variant = 2<<18,
    rare_amino_acid_variant = 2<<19,
    splice_acceptor_variant = 2<<20,
    splice_donor_variant = 2<<21,
    splice_region_variant = 2<<22,
    stop_lost = 2<<23,
    five_prime_UTR_premature = 2<<24,
    start_codon_gain_variant = 2<<25,
    start_lost = 2<<26,
    stop_gained = 2<<27,
    synonymous_variant = 2<<28,
    start_retained = 2<<29,
    stop_retained_variant = 2<<30,
    non_canonical_start_codon = 2<<31,
    transcript = 2<<34,
    regulatory_region_variant = 2<<35,
    upstream_gene_variant = 2<<36,
    three_prime_UTR_variant = 2<<37,
    three_prime_UTR_truncation_and_exon_loss = 2<<38,
    five_prime_UTR_variant = 2<<39,
    five_prime_UTR_truncation_and_exon_loss_variant = 2<<40,
    five_prime_UTR_premature_start_codon_gain_variant = 2<<41,
    sequence_feature_and_exon_loss_variant = 2<<42


EffectNames = {
    Effect.none : "None",
    Effect.coding_sequence_variant : "Coding",
    Effect.chromosome : "Chromosome",
    Effect.inframe_insertion : "Inframe_Insertion",
    Effect.disruptive_inframe_insertion : "Disruptive_Inframe_Insertion",
    Effect.inframe_deletion : "Inframe_Deletion",
    Effect.disruptive_inframe_deletion : "Disruptive_Inframe_Deletion",
    Effect.downstream_gene_variant : "Downstream",
    Effect.exon_variant : "Exon",
    Effect.exon_loss_variant : "Exon_Loss",
    Effect.frameshift_variant : "Frameshift",
    Effect.gene_variant : "Gene",
    Effect.intergenic_region : "Intergenic",
    Effect.conserved_intergenic_variant : "Conversed_intergenic",
    Effect.intragenic_variant : "Intragenenic",
    Effect.intron_variant : "Intron",
    Effect.conserved_intron_variant : "Convered_Intron",
    Effect.miRNA : "miRNA",
    Effect.missense_variant : "Missense",
    Effect.initiator_codon_variant : "Init",
    Effect.non_coding_exon_variant : "Non_Coding",
    Effect.rare_amino_acid_variant : "Rare_Amino_Acid",
    Effect.splice_acceptor_variant : "Splice_Acceptor",
    Effect.splice_donor_variant : "Splice_Donor",
    Effect.splice_region_variant : "Splice_Region",
    Effect.stop_lost : "Stop_Lost",
    Effect.five_prime_UTR_premature : "5'UTR_Premature",
    Effect.start_codon_gain_variant : "Start_Gain",
    Effect.start_lost : "Start_Lost",
    Effect.stop_gained : "Stop_Gain",
    Effect.synonymous_variant : "Synonymous",
    Effect.start_retained : "Start_Retained",
    Effect.stop_retained_variant : "Stop_Retained",
    Effect.non_canonical_start_codon : "Non Canonical Start Codon",
    Effect.transcript : "Transcript",
    Effect.regulatory_region_variant : "Regulatory_Region",
    Effect.upstream_gene_variant : "Upstream",
    Effect.three_prime_UTR_variant : "3'UTR",
    Effect.three_prime_UTR_truncation_and_exon_loss : "3'UTR_Truncation_Exon_Loss",
    Effect.five_prime_UTR_variant : "5'UTR",
    Effect.five_prime_UTR_truncation_and_exon_loss_variant : "5'UTR_Truncation_Exon_Loss",
    Effect.five_prime_UTR_premature_start_codon_gain_variant : "5'UTR_Premature_Start_Gain",
    Effect.sequence_feature_and_exon_loss_variant : "Sequence_Feature_Loss"
}

exon_effects = [
    Effect.coding_sequence_variant,
    Effect.inframe_insertion,
    Effect.disruptive_inframe_insertion,
    Effect.inframe_deletion,
    Effect.exon_variant,
    Effect.exon_loss_variant,
    Effect.frameshift_variant,
    Effect.missense_variant,
    Effect.initiator_codon_variant,
    Effect.rare_amino_acid_variant,
    Effect.stop_lost,
    Effect.start_codon_gain_variant,
    Effect.start_lost,
    Effect.stop_gained,
    Effect.synonymous_variant,
    Effect.start_retained,
    Effect.stop_retained_variant,
    Effect.transcript,
    Effect.sequence_feature_and_exon_loss_variant,
    Effect.splice_acceptor_variant,
    Effect.splice_donor_variant,
    Effect.splice_region_variant,
]

